import javax.swing.*;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.util.Random;

public class DrawingMap extends JPanel{
    private final FormMap Map;
    private AbstractMap _abstractMap;
    BufferedImage bufferedImage;

    public DrawingMap(FormMap map){
        Map=map;
        _abstractMap = new SimpleMap();
    }

    @Override
    protected void paintComponent(Graphics g) {
        super.paintComponent(g);
        g.drawImage(bufferedImage,0,0,null);
    }

    private void SetData(DrawingWarship warship) {
        Random rand=new Random();
        warship.SetPosition(rand.nextInt(100)+10,rand.nextInt(100)+10,getWidth(),getHeight());
        Map.SpeedLabel.setText("Скорость: "+warship.GetWarship().GetSpeed());
        Map.WeightLabel.setText("Вес: "+warship.GetWarship().GetWeight());
        Map.BodyColorLabel.setText("Цвет: "+Integer.toHexString(warship.GetWarship().GetBodyColor().getRGB()).substring(2));
        bufferedImage = _abstractMap.CreateMap(700,550,new DrawingObjectWarship(warship));
    }
    public void CreateButtonAction(){
        Random rand=new Random();
        Color color1 = JColorChooser.showDialog(Map, "Выберите цвет тела корабля", null);
        if(color1==null)
            color1=new Color(rand.nextInt(256), rand.nextInt(256), rand.nextInt(256));
        DrawingWarship warship=new DrawingWarship(rand.nextInt(50)+10,rand.nextInt(3000)+20000,color1,rand.nextInt(3));
        SetData(warship);
    }
    public void CreateModifButtonAction(){
        Random rand=new Random();
        Color color1=JColorChooser.showDialog(Map, "Выберите цвет тела корабля",null);
        Color color2=JColorChooser.showDialog(Map, "Выборите цвет модификаций корабля",null);
        if(color1==null)
            color1=new Color(rand.nextInt(256), rand.nextInt(256), rand.nextInt(256));
        if (color2==null)
            color2=new Color(rand.nextInt(256), rand.nextInt(256), rand.nextInt(256));
        DrawingWarship warship = new DrawingAdvancedWarship(rand.nextInt(50) + 10, rand.nextInt(3000) + 20000, color1,
                color2, rand.nextBoolean(), rand.nextBoolean(), rand.nextBoolean(),rand.nextInt(3));
        SetData(warship);
    }
    public void DirectionButtonAction(Direction side){
        if(_abstractMap != null){
            bufferedImage = _abstractMap.MoveObject(side);
        }
    }

    public void ComboBoxSelectorMapAction(String name){
        switch (name){
            case "Простая карта":
                _abstractMap = new SimpleMap();
                break;
            case "Вторая карта":
                _abstractMap = new SecondMap();
                break;
        }
    }

    public void DrawMap(Graphics g){
        g.drawImage(bufferedImage,0,0,null);
    }
}
